{
  Este programa foi baseado nas aulas de Desenho Geomtrico
  ministradas pelo professor Windson, no curso de
  Licenciatura Plena em Matemtica da
  Universidade Federal de Rondnia.

  Autor....: Daniel P. Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte

  IMPORTANTE!

  Este programa pode ser redistribudo, desde que os crditos
  do autor sejam mantidos.
}

unit uEspiral;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Math;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    Rodando: boolean;
    procedure Arco(const Centro: TPoint; const Raio,
      Angulo1, Angulo2: integer);
    procedure FalsaEspiral;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ Em vez de criar a procedure Arco() poderamos ter usado
  o mtodo Canvas.Arc(), mas eu queria que o traado do arco
  fosse feito lentamente. O mtodo Canvas.Arc traa o arco
  instantaneamente e portanto no servia para meu propsito.

  Cada ponto do arco possui como coordenadas o par ordenado
  [cos(x), sen(x)], sendo x o ngulo que determina o ponto dado.
  Para traar o arco apenas liguei os diversos pontos que
  foram calculados a partir dos angulos dados.
}

procedure TForm1.Arco(const Centro: TPoint; const Raio,
  Angulo1, Angulo2: integer);

  function PontoDoAngulo(const Angulo: integer): TPoint;
  var
    X, Y: Extended;
  begin
    X := Cos(DegToRad(Angulo));
    Y := Sin(DegToRad(Angulo));
    Result.x := Centro.x + Round(X * Raio);
    Result.y := Centro.y - Round(Y * Raio);
  end;

var
  Angulo: integer;
  P: TPoint;
begin
  P := PontoDoAngulo(Angulo1);
  Canvas.MoveTo(P.x, P.y);

  for Angulo := Angulo1 to Angulo2 do
  begin
    P := PontoDoAngulo(Angulo);
    Canvas.LineTo(P.x, P.y);
    Sleep(10);
  end;
end;

procedure TForm1.FalsaEspiral;
const
  Variacao = 5;
  Espiras = 15;
var
  Centro, Centro1, Centro2: TPoint;
  I, Raio, Angulo1, Angulo2: integer;
begin
  Repaint;
  Rodando := true;
  
  Raio := Variacao;

  Centro1.x := ClientWidth div 2;
  Centro1.y := ClientHeight div 2;

  Centro2.x := Centro1.x + Raio;
  Centro2.y := Centro1.y;

  for I := 1 to Espiras * 2 do
  begin
    if I mod 2 = 1 then
    begin
      Centro := Centro1;
      Angulo1 := 0;
      Angulo2 := 180;
    end
    else
    begin
      Centro := Centro2;
      Angulo1 := 180;
      Angulo2 := 360;
    end;

    Arco(Centro, Raio, Angulo1, Angulo2);
    Raio := Raio + Variacao;

    Application.ProcessMessages;
    if not Rodando then
      Break;

  end;

  Rodando := false;
  Button1.Caption := 'Iniciar';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not Rodando then
  begin
    Button1.Caption := 'Parar';
    FalsaEspiral;
  end
  else
  begin
    Rodando := false;
    Button1.Caption := 'Iniciar';
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Rodando := false;
  Button1.Caption := 'Iniciar';
end;

end.
